<?
/**
 * 	This file is part of alicecms.
 *
 * alicecms is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * alicecms is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with alicecms; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @author Timm Maass <info@timm-maass.de>
 * @copyright &copy; 2005-2006 The ALiCE-CMS Project Team
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @package alicecms
 */
 
class class_ALiCE {

	var $version	= "1.6 beta";
	var $homesiteid = 1;
	var $designid	= 1;	
	var $styleid	= 1;	
	var $installed  = 0;
	var $configfile = "config/config.php";
	
	function class_ALiCE() {
		global $CONFIG, $ALiCEMODULES, $mod;
		if(!isset($_SESSION)) session_start();				
		// 0 for no errors E_ALL for all errors
		error_reporting (E_ALL);
		//error_reporting (0);
		require_once "class_ALiCE_MySQL.php";
		require_once "class_ALiCE_install.php";
		$install = new class_ALiCE_install;
		if($install->installcheck($this->configfile) == true) {
			$this->installed = 1;		
			require_once($this->configfile);
			$this->set_mysqltables();		
			require_once $CONFIG['local_root'].'ALiCElib/MAASSlib/MAASSfunctions.php';
			require_once $CONFIG['local_root'].'ALiCElib/MAASSlib/class_fileupload.php';
			require_once $CONFIG['local_root'].'modules/moduleconfig.inc.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Modules.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_User.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Usergroups.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_sessionlogin.php';		
			$mod = new class_ALiCE_modules;	
			$ALiCEMODULES['root'] = true;
			if(isset($ALiCEMODULES)){
				foreach($ALiCEMODULES as $m => $val) {
					$filename = $CONFIG['local_root'].'modules/'.$m.'/index.php';
					if(file_exists($filename)) {
						require_once $filename;
					}					
				}
			}			
			require_once $CONFIG['local_root'].'ALiCElib/VALIDATOR/validator.php'; 
			require_once $CONFIG['local_root'].'ALiCElib/BBCODE/bbcode.inc.php';
			require_once $CONFIG['local_root'].'ALiCElib/BBCODE/url_syntax.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_BBcode.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Styles.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Templates.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Element.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_filesystem.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Site.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Design.php';
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_Treemenu.php';						
			require_once $CONFIG['local_root'].'ALiCElib/class_ALiCE_export.php';						
		} else { $this->installed = 0;	}
	}
	
	function init() {	
		if($this->installed == 1) { 	print $this->getALiCE_complete();	}
	}	
	
	function set_mysqltables() {
		global $CONFIG;
		$CONFIG['mysql']['table_design']			= "alice_design";
		$CONFIG['mysql']['table_elements']			= "alice_elements";
		$CONFIG['mysql']['table_sites']				= "alice_sites";
		$CONFIG['mysql']['table_stylez']			= "alice_stylez";
		$CONFIG['mysql']['table_templates']			= "alice_templates";
		$CONFIG['mysql']['table_user']				= "alice_user";
		$CONFIG['mysql']['table_userrechte']		= "alice_userrechte";
		$CONFIG['mysql']['table_usergroups']		= "alice_usergroups";
		$CONFIG['mysql']['table_modules']			= "alice_modules";
	}
			
	function getALiCE_maincontent() {	
		global $CONFIG;
		if(!isset($_GET['siteid'])) { $siteid = 1; } else { $siteid = $_GET['siteid']; }
		$cdb 	= new class_mysql;
		$elt 	= new class_ALiCE_element;
		$inhalt = "";
		$cdb->select("select secure, public from ".$CONFIG['mysql']['table_sites']." where siteid= '$siteid'");
		$daten  = $cdb->fetchArray();
		$secure = $daten[0];
		$public = $daten[1];
		if($public == 'true') {
			if($secure == 'true') {
				$sl 		= new class_ALiCE_sessionlogin;
				$sl->siteid = $siteid;
				$loginform  = $sl->login_form();
				$success    = $sl->auth();		
				if($success){ $inhalt .= $sl->loginfo(); }
			} else { $success = true; }	
			
			if ($success) {
				$cdb->select("select e.id
				from ".$CONFIG['mysql']['table_sites']." s LEFT JOIN  ".$CONFIG['mysql']['table_elements']." e 
				USING(siteid) where s.siteid=$siteid ORDER BY e.da_order");
				$count  = $cdb->getRecords();
				while( $daten = $cdb->fetchArray() ) {
					$elementid = $daten[0];  
					$inhalt   .= $elt->get_element($elementid);	
				}
			} else { $inhalt .= $loginform;	}
		}
		return $inhalt;
	}
	
	function getALiCE_complete(){
		global $siteid, $CONFIG, $id, $mod;
		if(!isset($siteid)) { $siteid = $this->homesiteid;}
		$designid 			= $this->designid;		
		$mod->type 			= "user";
		$cdb 				= new class_mysql;
		$ASstyles			= new class_ALiCE_styles;
		$ASsite				= new class_ALiCE_Site;
		$cdb->select("SELECT * from ".$CONFIG['mysql']['table_design']." where designid='$designid'");                     
		$row				= $cdb->fetchArray();
		$d_content 			= $row['content'];
		$STYLES			    = $ASstyles->get_cssstylez($this->styleid);
		$name				= $ASsite->get_sitenameByID($siteid);
		$d_content			= $mod->modultags_ersetzen($d_content);		
		$d_content			= $mod->modultags_ersetzen($d_content);		
		$result 			= "
		<!doctype html public \"-//W3C//DTD HTML 4.0 Transitional//EN\">
		 <html><head>
		 <title>".$CONFIG['projektname']." - $name</title>
		 $STYLES				 
		 </head>
		 <body> $d_content </body>
		 </html>";  
		 return $result;
	}
	 
		
	function get_sitename() {
		global $CONFIG, $siteid;
		$ASsite				= new class_ALiCE_Site;
		if(!isset($siteid)) { $siteid = $this->homesiteid;}
		$name		= $ASsite->get_sitenameByID($siteid);
		$result		= "$name";
		return $result;
	}
	
	
	
	function print_javascript()	{		
		$javascript = "
		<script language=\"JavaScript\">
		<!--	
		function launch(newURL, newName, newFeatures, orgName) {
			var remote = open(newURL, newName, newFeatures);
			if (remote.opener == null)
				remote.opener = window;
			remote.opener.name = orgName;
			return remote;
		}
		function reloadclose()	{
			opener.location.reload();
			self.close();
		}	
		function schliessen(nn){ 
			window.setTimeout(\"window.reloadclose()\",(nn*1000) );
		}	
		function popup(url, name, width, height) {
			mywinpos = findscreencenter(width,height);
			settings=
			\"toolbar=no,location=no,directories=no,\"+
			\"status=no,menubar=no,scrollbars=yes,\"+
			\"resizable=yes,width=\"+width+\",height=\"+height+\",top=\"+mywinpos[0]+\",left=\"+mywinpos[1];
			orgname=\"mymain\";		
			MyNewWindow=launch(url,name,settings,orgname);
		}		
		function findscreencenter( pwinwidth, pwinheight )	{
			winpos 		= new Array(2);
			scrheight 	= screen.height;
			scrwidth 	= screen.width;
			wintop 		= (scrheight - pwinheight-100) / 2;
			winleft 	= (scrwidth - pwinwidth) / 2;
			winpos[0] 	= wintop;
			winpos[1] 	= winleft;
			return winpos;
		}	
		//-->
		</script>";
		return $javascript;
	}
	
	
	
	# datawarehouse allgemein
	# zum versenden von einfachen Html Mails ohne Anhang
	function mailit($von,$an,$betreff,$content){
		global $msg;
		$mail_header = "From: $von";
		$mail_header .= "\nContent-Type: text/html";
		$mail_header .= "\nContent-Transfer-Encoding: 8bit";
		$mail_header .= "\n\n
						 <!doctype html public \"-//W3C//DTD HTML 4.0 Transitional//EN\">
						 <HTML><HEAD><TITLE>AutomatischeEmail</TITLE>\n
						 .styles().
						 </HEAD>
						 <body class=\"text\">
						 $content
						 </body>
						 </html>";
		
		if(mail($an,$betreff,"",$mail_header)) { $msg .= "Die Email wurde an".htmlentities($an)."gesendet.\n"; } 
										  else { $msg .= "Es ist ein Fehler beim senden der eMail an $an aufgetreten.\n"; }
	}

}



class class_ALiCE_siteadmin extends class_ALiCE {


	function init_siteadmin() {
		if($this->installed == 1) {
			$this->getALiCE_siteadmin();		
		} else {
			$this->getALiCE_installer();
		}
	}
	
	function getALiCE_installer() {
		$install = new class_ALiCE_install;
		$content 	= $install->installation();
		$links 		= $install->installation_links();
		$sonstiges  = $install->msg;
		$this->siteadmin_printwebsite("Installation",$content,$links,"",$sonstiges);
	}
	
	function getALiCE_siteadmin() {
		global $action, $id, $session, $PHP_SELF, $link_info, $mod, $msg, $log_msg;
				
		$mod->type 	= "admin";		   
		if (!isset($action) or ($action=="")) { $action = "home"; }
		$ug 		= new class_ALiCE_Usergroups;
		$sl 		= new class_ALiCE_sessionlogin;
		$sl->logout(); 
		$loginform  = $sl->adminlogin_form();
		$success    = $sl->auth();	
		$log_msg  	= $sl->loginfo();	
		$titel			= "Login";
		$inhalt			= $loginform;
		$local_links	= "";
		
		if($success == true) {
			if($action == "downloaddump") {
				global $file;
				if( isset($file)){				
						header("Pragma: private");
						header("Expires: 0");    
						header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
						header('Content-Description: File Transfer'); 
						header('Content-Type: application/force-download'); 
						header('Content-Length: ' . filesize('dump/'.$file)); 
						header('Content-Disposition: attachment; filename=' . basename($file)); 
						readfile('dump/'.$file); 
						exit;
				}
			}
			if($action == "popup_imageselecta") {
				$bld 	 	= new class_ALiCE_filesystem();
				$inhalt 	= $bld->get_elementcontent_imageselecta();
				$this-> siteadmin_printpopup("ALiCE - Imageselecta",$inhalt);
				exit;
			}
			if($action == "popup_moduletaginfo") {
				$inhalt = $mod->get_taginfo();
				$this->siteadmin_printpopup("ALiCE - Taginfo",$inhalt);
				exit;
			}
			if($action == "popup_moduleinstaller") {
				global $modulename;
				if(!isset($modulename)) { echo "Fehler"; exit; }
				$inhalt 	= $mod->show_installer($modulename);
				$this->siteadmin_printpopup("ALiCE - Moduleinstaller",$inhalt);
				exit;
			}
			
			if ($action == "adminstylez"){
				$check = $ug->check_userrights($id,"styles",0);
				if($check == true) {
					$ALstyles 		= new class_ALiCE_styles;
					$titel			= "CSS Styles";
					$inhalt			= $ALstyles->init();
					$local_links	= $ALstyles->get_styleNavi('list');
				}
				
			} elseif ($action == "module") {
				$check = $ug->check_userrights($id,"modules",0);
				if($check == true) {
					$titel        	= "Module";
					$local_links  	= "";
					$inhalt 	  	= $mod->show_modules();
				}
				
			} elseif ($action == "home") {		
				$inhalt 	 	= $this->siteadmin_home();
				$titel  	 	= "Admin Home";
				$local_links 	= "";
				
			}  elseif ($action == "tutorials") {		
				$inhalt 	 	= "";
				$titel  	 	= "Tutorials";
				$local_links 	= "";
				
			} elseif ($action == "design") {
				$check = $ug->check_userrights($id,"design",0);
				if($check == true) {
					$dsn 			= new class_ALiCE_design;
					$titel 			= "Design";			
					$local_links 	= "";
					$inhalt 		= $dsn->init();
				}
				
			} elseif ($action == "templates") {		
				$check = $ug->check_userrights($id,"templates",0);
				if($check == true) {
					$tpl 		 	= new class_ALiCE_Templates;
					$titel		 	= "Templates"; 
					$local_links 	= "";
					$inhalt      	= $tpl->init();		
				}
				
			} elseif ($action == "styles") {		
				$check = $ug->check_userrights($id,"styles",0);
				if($check == true) {
					$stl 		 	= new class_ALiCE_styles;
					$titel		 	= "Styles"; 
					$local_links 	= "";
					$inhalt      	= $stl->init();			
				}
				
			} elseif ($action == "struktur") {			
				$check = $ug->check_userrights($id,"struktur",0);
				if($check == true) {
					$ste         	= new class_ALiCE_Site;
					$titel		 	= "Struktur";
					$inhalt      	= $ste->init_struktur();
					$local_links 	= $ste->init_treemenu();	
				}
				
			} elseif ($action == "bilder") {		
				$check = $ug->check_userrights($id,"filesystem",0);
				if($check == true) {
					$titel          = "Filesystem";
					$fsy            = new class_ALiCE_filesystem;
					$inhalt         = $fsy->init();
					$local_links    = $fsy->ordnernavi();
				}
				
				
			} elseif ($action == "user") {	
				$check = $ug->check_userrights($id,"user",0);
				if($check == true) {	
					$usr            = new class_ALiCE_User;
					$titel 		 	= $usr->get_title();
					$local_links 	= $usr->get_locallinks();
					$inhalt 	 	= $usr->get_content();
				}
			} elseif ($action == "usergroups") {		
				$check = $ug->check_userrights($id,"usergroups",0);
				if($check == true) {	
					$titel 		 	= $ug->get_title();
					$local_links 	= $ug->get_locallinks();
					$inhalt 	 	= $ug->get_content();
				}
			} elseif ($action == "export") {		
				$check = $ug->check_userrights($id,"export",0);
				if($check == true) {	
					$ex 		= new class_ALiCE_export;
					$titel 		 	= $ex->get_title();
					$local_links 	= "";
					$inhalt 	 	= $ex->get_content();
				}
			} else {
				$r 				= $mod->sectionweiche($action);
				$local_links 	= $r['local_links'];
				$titel 			= $r['titel'];
				$inhalt 		= $r['inhalt'];
			}         
		} 
		$links 		 = $this->siteadmin_getsections();
		$this->siteadmin_printwebsite($titel,$inhalt,$links,$local_links,$msg);
		
	}
	
	
	function siteadmin_getsections() {	
		global $PHP_SELF, $link_info, $mod, $id;
		
		$ug 		= new class_ALiCE_Usergroups;
		$sl 		= new class_ALiCE_sessionlogin;
		$success    = $sl->auth();	
		
		$linkstyle   = " style=\"background-image:url('pics/buttonbg.gif');margin-bottom:5px\"";
		$links 		 = "<div $linkstyle><a href=\"index.php\" target=\"_blank\"	>&nbsp;zur Website</a></div>";
		
		if($success) { $check = $ug->check_userrights($id,"siteadmin",0); } else { $check = false; }
		if($check == true) {
			$links 	.= "<div $linkstyle><a href=\"$PHP_SELF?&$link_info\" >&nbsp;Home</a></div><br>";
		}
		
		if($success) { $check = $ug->check_userrights($id,"struktur",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=struktur&pos=0|1|X&$link_info\" >&nbsp;Struktur</a></div>";
		}
		if($success) { $check = $ug->check_userrights($id,"filesystem",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=bilder&$link_info\" >&nbsp;Filesystem</a></div><br>";
		}
		
		if($success) { $check = $ug->check_userrights($id,"design",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=design&$link_info\" >&nbsp;Design</a></div>";
		}
		if($success) { $check = $ug->check_userrights($id,"styles",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=styles&$link_info\" >&nbsp;Styles</a></div>";
		}
		if($success) { $check = $ug->check_userrights($id,"templates",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=templates&$link_info\" >&nbsp;Templates </a></div>";
		}
		if($success) { $check = $ug->check_userrights($id,"modules",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=module&$link_info\" >&nbsp;Module</a></div><br>";
		}
		if($success) { $check = $ug->check_userrights($id,"user",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=user&$link_info\"	>&nbsp;User</a></div>";
		}
		if($success) { $check = $ug->check_userrights($id,"usergroups",0); } else { $check = false; }
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=usergroups&$link_info\" >&nbsp;Usergruppen</a></div>";
		}
		
		$check = $ug->check_userrights($id,"export",0);
		if($check == true) {
			$links .= "<div $linkstyle><a href=\"$PHP_SELF?action=export&$link_info\" >&nbsp;Export</a></div>";
		}
		
		$modlinks = $mod->get_sections();
		foreach($modlinks as $m) {
			if($success) { $check = $ug->check_userrights($id,$m['name'],0); } else { $check = false; }
			if($check == true) {
				$links .= "	<div $linkstyle><a href=\"$PHP_SELF?&$link_info&action=".$m['action']."\">&nbsp;".$m['name']."</a></div><br>";
			}
			
		}
		return $links;
	}
	
	function siteadmin_home() {
		global $CONFIG, $PHP_SELF, $link_info, $mod, $id;
		$cdb = new class_mysql;
		$cdb->select("SELECT * from ".$CONFIG['mysql']['table_sites']." ");
		$site_count = $cdb->getRecords();
		$cdb->select("SELECT * from ".$CONFIG['mysql']['table_templates']." ");
		$tpl_count = $cdb->getRecords();
		
		$linkstyle  = " style=\"background-image:url('pics/buttonbg.gif');margin-bottom:5px;width:150px;\"";
		$ug 		= new class_ALiCE_Usergroups; 
		
		
		$check 		= $ug->check_userrights($id,"design",0);
		$links = array();
		$links[] 		 = "<div $linkstyle><a href=\"index.php\" target=\"_blank\"	>&nbsp;zur Website</a></div>";
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=design&$link_info\" >&nbsp;Design</a></div>";
		}
		
		$check = $ug->check_userrights($id,"styles",0);
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=styles&$link_info\" >&nbsp;Styles</a></div>";
		}
		$check = $ug->check_userrights($id,"templates",0);
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=templates&$link_info\" >&nbsp;Templates </a></div>";
		}
		$check = $ug->check_userrights($id,"templates",0); 
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=struktur&pos=0|1|X&$link_info\" >&nbsp;Struktur</a></div>";
		}
		$check = $ug->check_userrights($id,"filesystem",0); 
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=bilder&$link_info\" >&nbsp;Filesystem</a></div>";
		}
		$check = $ug->check_userrights($id,"modules",0);
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=module&$link_info\" >&nbsp;Module</a></div>";
		}
		$check = $ug->check_userrights($id,"user",0);
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=user&$link_info\" >&nbsp;User</a></div>";
		}
		$check = $ug->check_userrights($id,"usergroups",0);
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=usergroups&$link_info\" >&nbsp;Usergruppen</a></div>";
		}
		$check = $ug->check_userrights($id,"export",0);
		if($check == true) {
			$links[] = "<div $linkstyle><a href=\"$PHP_SELF?action=export&$link_info\" >&nbsp;Export</a></div>";
		}
		
		$modlinks = $mod->get_sections();
		foreach($modlinks as $m) {
			$check = $ug->check_userrights($id,$m['name'],0);
			if($check == true) {
				$links[] = "<div $linkstyle><a href=\"$PHP_SELF?&$link_info&action=".$m['action']."\">&nbsp;".$m['name']."</a></div>";
			}			
		}
		
		$userlinks = "<table border=0 width=\"100%\">";
		$j = 0;
		for($j=0;$j<count($links);$j=$j){
			$userlinks .= "<tr>";
			for($i=0;$i<3;$i++) {
				if(isset($links[$j])) { $content = $links[$j]; } else { $content = "&nbsp;"; }
				$userlinks .= "<td>$content</td>";
				$j++;
			}
			$userlinks .= "</tr>";
		}
		$userlinks .= "</table>";
		
		 $inhalt ="
		 <table width=\"100%\" class=\"alice\" cellspacing=\"0\" cellpadding=\"0\">
		 <tr><td valign=\"top\" width=\"400px\">Willkommen auf der Konfigurationsoberflche von <b>ALiCE ".$this->version."</b>,
				 Ihrem zuverlssigen Homepageassistenten.<br><br>
				 Falls sie Hilfe bei der Erstellung ihrer Website bentigen, benutzen
				 Sie bitte das <a href=\"\">Alice Tutorial</a>.</td>
		 <td >
		 <div> <img src=\"pics/info.gif\"> Dieses Projekt besteht aus insgesamt <b> $site_count Webseiten</b>.</div><br>
		 <div> <img src=\"pics/info.gif\"> Es sind <b> $tpl_count Templates</b> verf&uuml;gbar.</div>
		 </td></tr></table>
		 <br>$userlinks";
		return $inhalt;
	}
	
	
	function siteadmin_getstyles() {
		$styles="
		<style type=\"text/css\">
		img 		{ border:0px; }
		body		{ font-family:Helvetica,Verdana,Arial,sans serif;  font-size:10pt; }
		h3			{ color:#66cc33; font-size:14pt; font-family:Helvetica,Verdana,Arial,sans serif; padding:1px; }
		h5			{ color:#000000; font-size:12pt; font-family:Helvetica,Verdana,Arial,sans serif; padding:1px; }
		a:link		{ color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans serif; font-weight:bold; text-decoration: none; }
		a:visited  	{ color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans serif; font-weight:bold; text-decoration: none; }
		a:hover 	{ color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans serif; font-weight:bold; text-decoration: none; }
		a:active 	{ color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans serif; font-weight:bold; text-decoration: none; }                
		 .alice		{ background-color: #FFFFFF; color:#999999; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans serif; padding:1px; }                
		 .alice2	{ background-color: #FFFFFF; color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans serif; border:1px; border-style:solid; border-color:black; }
		 .alice3		{ background-color: #66cc33; color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans-serif; font-weight:bold; padding:1px; }
		 .alice4		{ background-color: #E8F9E4; color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans-serif; padding:1px; }                
		 .alice5		{ background-color: #EEEEEE; color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans-serif; padding:1px; }                
		 .alicewhite	{ background-color: white; color:#000000; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans-serif; padding:1px; }
		 .alicedefaultcontent	{  color:red; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans-serif; padding:1px; }
		 .alicetextarea		{  color:#333333; font-family:Courier; font-size:8pt  }                
		 .msg		{   color:red; font-size:10pt; font-family:Helvetica,Verdana,Arial,sans serif; padding:1px; }
		  						  
		.bbcodehilfe1	{    cursor:hand; margin:10px; padding:10px; display:inline; } 
	
		</style>";
		return $styles;
	}
	
	
	
	function siteadmin_printpopup($titel,$inhalt,$logged=true) {
		global $PHP_SELF, $log_msg, $msg, $link_info, $CONFIG;	
		$success = false;
		if($logged == true) {
			$sl 		= new class_ALiCE_sessionlogin;
			$sl->logout(); 
			$loginform  = $sl->adminlogin_form();
			$success    = $sl->auth();		
		} else { $success = true; }
		$styles 		= $this->siteadmin_getstyles();	
		$javascript  	= $this->print_javascript();    	
		print "
		<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\">
		<HTML>
		<HEAD>
		$styles
		$javascript
		<TITLE>$titel</TITLE></HEAD>
		<BODY >";
		if($success) {	
			print" $msg \n $inhalt \n </body>";		
		} else {
			print "$loginform</body></html>";
		}
	}
	
	
	function siteadmin_printwebsite($titel,$inhalt,$links,$local_links="",$sonstiges="") {
		global $PHP_SELF, $log_msg, $link_info, $CONFIG;	
		
		$styles 	 = $this->siteadmin_getstyles();	
		$javascript  = $this->print_javascript();    	
		print "
		<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\">
		<HTML><HEAD> \n	$styles \n	$javascript
		<TITLE>$titel</TITLE></HEAD>
		<BODY>";
			        
		$oben 		 = "";         
		if($local_links != "") {
			$local_links = "
			<div style=\"width:150px;height:200px;background-color:white;padding:5px;
			overflow:auto;border:2px solid #66cc33;\"><div style=\"width:500px;height:180px\">$local_links</div></div>";
		} else {
			$local_links = "
			<div style=\"width:150px;height:200px;background-color:white;padding:0px;
			overflow:hidden;border:2px solid #66cc33;\"><img src=\"pics/haseneu.jpg\"></div>";
		}
		if($sonstiges != "") {
			$sonstiges = "<div class=\"msg\"><img src=\"pics/msg.gif\" width=\"20\" height=\"20\" ><b> $sonstiges</b><br></div>";
		}		
		print "
		<TABLE width=\"800\" height=\"600\" cellspacing=\"0\" cellpadding=\"0\"  border=0>
		<tr valign=\"top\" height=\"50px\"><td width=\"150px\" align=\"center\"><img src=\"pics/logo.gif\" ></td>
			<td  class=\"alice\" align=\"right\">
			<div style=\"margin-left:15px;\"   class=\"alice\">$log_msg </div>
			<marquee  style=\"margin-left:15px;\"  class=\"alice4\">  -  Herzlich Willkommen zu <b>ALiCE $this->version</b> - </marquee></td></tr>    
		<tr valign=\"top\"><td width=\"150px\" class=\"alice\">
			<div style=\"width:150px;height:300px;background-color:white;padding:5px;border:2px solid #66cc33;\">$links</div>
			<div style=\"width:140px;font-weight:bold;padding:5px;\" >>>> $titel</div>
			$local_links</td>
			<td valign=\"top\"><div style=\"margin-left:15px;margin-right:5px;margin-top:1px;width:635px;\">$sonstiges $inhalt</div></td></tr>   
		</table>";
	}
	
	
}


?>
