<?
/**
 * 	This file is part of alicecms.
 *
 * alicecms is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * alicecms is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with alicecms; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @author Timm Maass <info@timm-maass.de>
 * @copyright &copy; 2005-2006 The ALiCE-CMS Project Team
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @package alicecms
 */

class class_ALiCE_BBcode{
		   
	// Die entscheidende BBcode Funktion: konfiguriert und lst aus
	function da_bbcode($content) {
		
		global $CONFIG;
		
	# So geht das:        
	#        $bbcode->addCode (
	#  'b',                         // Name
	#  'simple_replace',            // Typ
	#  null,                        // Funktion zum Aufrufen
	#  array ('<b>', '</b>'),       // Funktionsparameter
	#  'inline',                    // Inhaltstyp
	#  array ('block', 'inline'),   // Erlaubt innerhalb von
	#  array ()                     // Nicht erlaubt innerhalb von 
	#  );
		
		$bbcode = new BBCode ();         
		// Zeilenumbrche vereinheitlichen fr alle
		$bbcode->addParser ('convertlinebreaks', array ('block', 'inline', 'link', 'listitem', 'list'));	
		// Nur fr nicht-Listen
		$bbcode->addParser ('htmlspecialchars', array ('block', 'inline', 'link', 'listitem'));	
		// nur fr Listenelemente
		$bbcode->addParser ('bbcode_striplastlinebreak', array ('listitem'));	
		// nur fr Nicht-Listen
		$bbcode->addParser ('nl2br', array ('block', 'inline', 'link', 'listitem'));	
		// nur fr Listen
		$bbcode->addParser ('bbcode_stripcontents', array ('list'));  
		
		// [b], [i], [h], [u], [klein], [center]
		$bbcode->addCode ('b', 'simple_replace', null, array ('<b>', '</b>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','center'), array ());	                  
		$bbcode->addCode ('i', 'simple_replace', null, array ('<i>', '</i>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','center'), array ());	                  
		$bbcode->addCode ('h', 'simple_replace', null, array ('<h3 style="display:inline;">', '</h3>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','center'), array ());	               
										  
		$bbcode->addCode ('u', 'simple_replace', null, array ('<u>', '</u>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','center'), array ());
							 
		$bbcode->addCode ('klein', 'simple_replace', null, array ('<font style="font-size:7 pt;">', '</font>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','center'), array ());       
	
		$bbcode->addCode ('center', 'simple_replace', null, array ('<div align="center">', '</div>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein'), array ());
		$bbcode->addCode ('right', 'simple_replace', null, array ('<div align="right">', '</div>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein'), array ());
		$bbcode->addCode ('left', 'simple_replace', null, array ('<div align="left">', '</div>'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein'), array ());
						  
		// Smilies
				   
		$bbcode->addCode ('smile', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/smile.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('sad', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/sad.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('shocked', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/shocked.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('biggrin', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/biggrin.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('wink', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/wink.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('tongue', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/tongue.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('artist', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/artist.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('bowling', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/bowling.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('mad', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/mad.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('dizzy', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/dizzy.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('nono', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/nono.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('eyepatch', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/eyepatch.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('sick', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/sick.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('cry', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/cry.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('uhh', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/uhh.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('wacko', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/wacko.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('yinyang', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/yinyang.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		$bbcode->addCode ('frog', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'pics/smilies/frog.gif" border="0">', '&nbsp;'),
						  'inline', array ('listitem', 'block', 'inline', 'link','klein','center'), array ());	   
		
		// [list]
		//   [*]Eintrag
		// [/list]                  
		$bbcode->addCode ('list', 'simple_replace', null, array ('<ul type=square>', '</ul>'),
						  'list', array ('block', 'listitem'), array ());                  
		$bbcode->addCode ('*', 'simple_replace', null, array ('<li>', "</li>"),
						  'listitem', array ('list'), array ());	            
		$bbcode->setCodeFlag ('*', 'no_close_tag', true);	      
						  
		// [url]http://...[/url], [url=http://...]Text[/url]
		$bbcode->addCode ('url', 'usecontent?', 'do_bbcode_url', array ('default'),
						  'link', array ('listitem', 'block', 'inline','center'), array ('link'));
		   
						  
		// [site=...]Text[/site]                  
		$bbcode->addCode ('site', 'usecontent?', 'do_bbcode_internlink', array ('default'),
						  'link', array ('listitem', 'block', 'inline','center'), array ('link')); 
						  
		// [blankurl]http://...[/url], [url=http://...]Text[/url]
		$bbcode->addCode ('blankurl', 'usecontent?', 'do_bbcode_blankurl', array ('default'),
						  'link', array ('listitem', 'block', 'inline','center'), array ('link'));
		   
						  
		// [blanksite=...]Text[/site]                  
		$bbcode->addCode ('blanksite', 'usecontent?', 'do_bbcode_blankinternlink', array ('default'),
						  'link', array ('listitem', 'block', 'inline','center'), array ('link'));               
						  
		// [img]http://...[/img]
		$bbcode->addCode ('img', 'usecontent', 'do_bbcode_img', array (),
						  'image', array ('listitem', 'block', 'inline', 'link','center'), array ());
						  
						  
		// [myimg] Bildname [/myimg]
		$bbcode->addCode ('myimg', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'upload/','" border="0" >'),
						  'inline', array ('listitem', 'block', 'inline', 'link'), array ());
		// [myimg_s] Bildname [/myimg_s]
		$bbcode->addCode ('myimgs', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'upload/150/','" border="0" >'),
						  'inline', array ('listitem', 'block', 'inline', 'link'), array ());
		// [myimg_m] Bildname [/myimg_m]
		$bbcode->addCode ('myimgm', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'upload/300/','" border="0">'),
						  'inline', array ('listitem', 'block', 'inline', 'link'), array ());
		// [myimg_l] Bildname [/myimg_l]
		$bbcode->addCode ('myimgl', 'simple_replace', null, array ('<img src="'.$CONFIG['root'].'upload/500/','" border="0">'),
						  'inline', array ('listitem', 'block', 'inline', 'link'), array ());
	
		// Nur zwei Bilder auf einmal
		#$bbcode->setOccurrenceType ('img', 'image');
		#$bbcode->setMaxOccurrences ('image', 2);
		
						  
		$content = $bbcode->parse ($content);    
		return $content; 
	}
	
}



	// Funktion zum berprfen der URL Syntax
	function do_bbcode_url ($tag_name, $attrs, $elem_contents, $func_param, $openclose) {
		global $imSiteadmin;
		// Tag hatte nicht das default-Attribut
		if ($openclose == 'all') {
			// invalid url
			if (check_url ($elem_contents, array ('http', 'ftp', 'mailto','javascript')) === false) {
				return false;
			}
			return '<a href="'.htmlspecialchars($elem_contents).'">'.htmlspecialchars($elem_contents).'</a>';
		// Tag hatte das default-Attribut und das hier ist der ffnende Tag
		} else if ($openclose == 'open') {
		  if($imSiteadmin == "struktur") {
			return '<a href="'.htmlspecialchars($attrs['default']).'">';
			#return '<a href="javascript:void(null);">';
		  } else {
			// invalid url
			if (check_url ($attrs['default'], array ('http', 'ftp', 'mailto')) === false) {
				return false;
			}
			return '<a href="'.htmlspecialchars($attrs['default']).'">';
			}
		// Tag hatte das default-Attribut und das hier ist der schlieende Tag
		} else if ($openclose == 'close') {
		  if($imSiteadmin == "struktur") {
			return '';
		  } else {
			return '</a>';
		}
		// Irgendwas seltsames geht vor sich
		} else {
			// Fehler
			return false;
		}
	}
	
	
	// Funktion zum berprfen der URL Syntax
	function do_bbcode_internlink ($tag_name, $attrs, $elem_contents, $func_param, $openclose) {
		global $root, $imSiteadmin, $link_info, $PHP_SELF;
		// Tag hatte nicht das default-Attribut
		if ($openclose == 'all') {
		  if($imSiteadmin == "struktur") {
			return '<a href="javascript:void(null);">'.htmlspecialchars($elem_contents).'</a>';
		  } else {
			return '<a href="'.$PHP_SELF.'?siteid=1">'.htmlspecialchars($elem_contents).'</a>';
		  }
		// Tag hatte das default-Attribut und das hier ist der ffnende Tag
		} else if ($openclose == 'open') {
	
		  if($imSiteadmin == "struktur") {
			return '';
			#return '<a href="javascript:void(null);">';
		  } else {
			return '<a href="'.$PHP_SELF.'?siteid='.htmlspecialchars($attrs['default']).'">';
		  }
		// Tag hatte das default-Attribut und das hier ist der schlieende Tag
		} else if ($openclose == 'close') {
		  if($imSiteadmin == "struktur") {
			return '';
		  } else {
			return '</a>';
		}
		// Irgendwas seltsames geht vor sich
		} else {
			// Fehler
			return false;
		}
	}
	


	// Funktion zum berprfen der URL Syntax
	function do_bbcode_blankurl ($tag_name, $attrs, $elem_contents, $func_param, $openclose) {
	global $imSiteadmin;
		// Tag hatte nicht das default-Attribut
		if ($openclose == 'all') {
			// invalid url
			if (check_url ($elem_contents, array ('http', 'ftp', 'mailto')) === false) {
				return false;
			}
			return '<a href="'.htmlspecialchars($elem_contents).'" target=\"_BLANK\">'.htmlspecialchars($elem_contents).'</a>';
		// Tag hatte das default-Attribut und das hier ist der ffnende Tag
		} else if ($openclose == 'open') {
		  if($imSiteadmin == "struktur") {
			return '<a href="javascript:void(null);">';
		  } else {
			// invalid url
			//if (check_url ($attrs['default'], array ('http', 'ftp', 'mailto')) === false) {
			//	return false;
			//}
			return '<a href="'.htmlspecialchars($attrs['default']).'" target=\"_BLANK\">';
		  }
		// Tag hatte das default-Attribut und das hier ist der schlieende Tag
		} else if ($openclose == 'close') {
			return '</a>';
		// Irgendwas seltsames geht vor sich
		} else {
			// Fehler
			return false;
		}
	}
	
	
	// Funktion zum berprfen der URL Syntax
	function do_bbcode_blankinternlink ($tag_name, $attrs, $elem_contents, $func_param, $openclose) {
		global $root, $imSiteadmin, $link_info, $PHP_SELF;
		// Tag hatte nicht das default-Attribut
		if ($openclose == 'all') {
		  if($imSiteadmin == "struktur") {
			return '<a href="#">'.htmlspecialchars($elem_contents).'</a>';
		  } else {
			return '<a href="'.$PHP_SELF.'?siteid=1" target=\"_BLANK\">'.htmlspecialchars($elem_contents).'</a>';
		  }
		// Tag hatte das default-Attribut und das hier ist der ffnende Tag
		} else if ($openclose == 'open') {
	
		  if($imSiteadmin == "struktur") {
			return '<a href="javascript:void(null);">';
		  } else {
			return '<a href="'.$PHP_SELF.'?siteid='.htmlspecialchars($attrs['default']).'" target=\"_BLANK\">';
		  }
		// Tag hatte das default-Attribut und das hier ist der schlieende Tag
		} else if ($openclose == 'close') {
			return '</a>';
		// Irgendwas seltsames geht vor sich
		} else {
			// Fehler
			return false;
		}
	}
	
	// Funktion zum Einbinden von Bildern
	function do_bbcode_img ($tag_name, $attrs, $elem_contents, $func_param, $openclose) {
		// Tag hatte nicht das default-Attribut
		if ($openclose == 'all') {
			// invalid url
			if (check_url ($elem_contents, array ('http', 'ftp', 'mailto')) === false) {
				return false;
			}
			return '<img src="'.htmlspecialchars($elem_contents).'" alt="" border="0">';
		// Irgendwas seltsames geht vor sich
		} else {
			// Fehler
			return false;
		}
	}
	
	// >DA_BBCODE: Alles bis auf Neuezeile-Zeichen entfernen
	function bbcode_stripcontents ($text) {
		return preg_replace ("/[^\n]/", '', $text);
	}
	
	// >DA_BBCODE: Den letzten Zeilenumbruch entfernen
	function bbcode_striplastlinebreak ($text) {
		$text = preg_replace ("/\n( +)?$/", '$1', $text);
		return $text;
	}
	
	// >DA_BBCODE: Zeilenumbrche verschiedener Betriebsysteme vereinheitlichen
	function convertlinebreaks ($text) {
		return preg_replace ("/\015\012|\015|\012/", "\n", $text);
	}

?>