<?
/**
 * 	This file is part of alicecms.
 *
 * alicecms is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * alicecms is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with alicecms; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @author Timm Maass <info@timm-maass.de>
 * @copyright &copy; 2005-2006 The ALiCE-CMS Project Team
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @package alicecms
 */

	
class class_ALiCE_modules {

	var $modules 			= array();
	var $type				= "user"; // user oder admin
	
    function tag_callback( $my_param_one, $my_param_two ) {
		$tag = $this->get_tagByName($my_param_one);
		$type = $this->type;
		if($tag != false) {
			if($type == "admin") {
				$function = $tag['function_admin'];
			} else {
				$function = $tag['function_user'];
			}
			if(function_exists($function)) {
				eval ("\$r = $function($my_param_two);");
			} else { $r = "<b>Fehler: Function <b>$function</b> doesnt exist.<br>" ; }
		} else { $r = "<b>Fehler: Tag <b>$my_param_one</b> doesnt exist.<br>" ; }
		#$r = $this->modultags_ersetzen($r);
		return $r;
    }
		
	function modultags_ersetzen($string){
		$return 	  = preg_replace( "!\{(.+?)\[(.*?)\]\}!e", "\$this->tag_callback('\\1', '\\2')", $string );
		return $return;	 
	} 
	 
	function add_module($modulename) {
		$modules = $this->modules;
		$modules[$modulename] = array(  
									"installer"		=> array(), 
									"sections"		=> array(), 
									"tags"			=> array(), 
									"options"		=> array(), 
									"usertypes"		=> array()
								);
		$this->modules = $modules;	
	}
	
	function get_modules() {
		global $ALiCEMODULES;
		$modules = $this->modules;
		$result = array();		
		foreach($modules as $name => $val) {
			if(isset($ALiCEMODULES[$name]) || ($name == 'root')){
				$result[$name] = $val;
			}
		}
		return $result;		
	}
	
	function add_section($modulename,$sectionname,$sectionaction,$sectionfunction,$sectionorder,$usertype,$description="") {
		$modules = $this->modules;
		if(!isset($modules[$modulename])) { return false; }
		$count 	 = count($modules[$modulename]['sections']);
		$modules[$modulename]['sections'][$count] = array(
														"name"			=> $sectionname,
														"action"		=> $sectionaction,
														"function"  	=> $sectionfunction,
														"order"			=> $sectionorder,
														"usertype"		=> $usertype,
														"description"	=> $description
													);
		$this->modules = $modules;	
	}
	
	function add_installer($modulename,$installfunction,$uninstallfunction) {
		$modules = $this->modules;
		if(!isset($modules[$modulename])) { return false; }
		$count 	 = count($modules[$modulename]['installer']);
		if($count > 0) return false;
		$modules[$modulename]['installer'][$count] = array(
														"installfunction"	=> $installfunction,
														"uninstallfunction"	=> $uninstallfunction
													);
		$this->modules = $modules;	
	}
		
	
	function add_usertype($modulename,$usertypename,$usertypedescription) {
		$modules = $this->modules;
		if(!isset($modules[$modulename])) { return false; }
		$count 	 = count($modules[$modulename]['usertypes']);
		$modules[$modulename]['usertypes'][$count] = array(
														"name"			=> $usertypename,
														"description"	=> $usertypedescription
													);
		$this->modules = $modules;	
	}
		
	function add_tag($modulename,$outputname,$outputfunction_user,$outputfunction_admin,$description="") {
		$modules = $this->modules;
		if(!isset($modules[$modulename])) { return false; }
		$count 	 = count($modules[$modulename]['tags']);
		$modules[$modulename]['tags'][$count] = array(
														"name"			  => $outputname,
														"description"	  => $description,
														"function_user"   => $outputfunction_user,
														"function_admin"  => $outputfunction_admin
													);
		$this->modules = $modules;	
	}
	
	function add_option($modulename,$optionname,$optiontype,$optiontypeset,$optionvalue) {
		global $CONFIG;
		$modules = $this->modules;
		if(!isset($modules[$modulename])) { return false; }
		$count 	 = count($modules[$modulename]['options']);
		$modules[$modulename]['options'][$count] = array(
														"name"			  	=> $optionname,
														"type"   			=> $optiontype,
														"typeset"  			=> $optiontypeset,
														"value"				=> $optionvalue
													);
		if(!isset($CONFIG['module'][$modulename][$optionname])) {
			$CONFIG['module'][$modulename][$optionname] = $optionvalue;
		}
		$this->modules = $modules;	
	}
		
	function get_tagByName($tagname) {
		$modules = $this->get_modules();
		foreach($modules as $m => $v) {
			foreach($v['tags'] as $key => $t) {
				if($t['name'] == $tagname) return $t;
			}
		}
		return false;
	}
	/*
		
	function add_mysqltable($modulename,$tablename,$tablesqlfunction) {
		$modules = $this->modules;
		if(!isset($modules[$modulename])) { return false; }
		$count 	 = count($modules[$modulename]['mysqltables']);
		$modules[$modulename]['mysqltables'][$count] = array(
														"name"		 => $tablename,
														"installer"  => $tablesqlfunction
													);
		$this->modules = $modules;	
	}
*/	
	
	
	
	function read_modulefolder() {	
		global $CONFIG;
		$dir = $CONFIG['local_root'].'modules/';
		$handle = opendir($dir); 
		$i 		= 0;
		$result = array();
		while ($file = readdir ($handle)) { 
			if ($file != "." && $file != "..") { 
				if( is_dir($dir.$file) ) {
					$result[$i] = "$file";
					$i++;
				}
			}
		}
		closedir($handle); 
		return $result;
	}
	
	
	function write_moduleconfig($somecontent) {	
		global $CONFIG;
		$dir 		= $CONFIG['local_root'].'modules/';		 
		$filename 	= 'moduleconfig.inc.php';		
		// Sichergehen, dass die Datei existiert und beschreibbar ist
		if (is_writable($dir.$filename)) {		
			if (!$handle = fopen($dir.$filename, "w+")) {
				 $result =  "Kann die Datei $dir.$filename nicht ffnen";
				 return $result;
			}		
			// Schreibe $somecontent in die geffnete Datei.
			if (!fwrite($handle, $somecontent)) {
				$result =  "Kann in die Datei $dir$filename nicht schreiben";
				 return $result;
			}		
			$result =  "Fertig, Datei $dir$filename wurde geschrieben";		
			fclose($handle);		
		} else {
			$result =  "Die Datei $dir$filename ist nicht schreibbar";
		}	
		return $result;
	}
	
	
	function show_installer($modulename) {
		$modules 	= $this->modules;
		$installer 	= $modules[$modulename]['installer'];
		$result 	= "";		
		if($this->is_installed($modulename)) {
			if(isset($installer[0]['uninstallfunction'])) {
				$function = $installer[0]['uninstallfunction'];
				$result = $function();
			}
		} else {				
			if(isset($installer[0]['installfunction'])) {
				$function = $installer[0]['installfunction'];
				$result = $function();
			}
		}
		return $result;
	}
	
	function is_installed($modulename) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->select("select * from ".$CONFIG['mysql']['table_modules']." where id = '$modulename'");
		return $cdb->getRecords();
	}
	
	function set_installed($modulename) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->query("insert into ".$CONFIG['mysql']['table_modules']." values ('$modulename')");		
	}
	function set_uninstalled($modulename) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->query("delete from ".$CONFIG['mysql']['table_modules']." where id = '$modulename' ");		
	}

	// formatiert module fr die Ausgabe
	// returns: Liste mit modulen
	function show_modules() {
		global $CONFIG, $PHP_SELF, $link_info, $module_submit, $postmod, $moduleconfig, $usertype,  $msg,$ALiCEMODULES;		
		$inhalt = "<h3>Module</h3>";
		$modules 		= $this->modules;
		if($module_submit){
			$modconf = "<?\n\n";
			if($postmod) {
				foreach($postmod as $m){
					$modconf .= "\$ALiCEMODULES['$m'] = true;\n";
				}
			}			
			if($moduleconfig) {
				foreach($moduleconfig as $mname => $c){
					$modconf .= "\n\n # Moduleconfig - Module: $mname\n\n";
					foreach($c as $cname => $cval) {
					$modconf .= "\$CONFIG['module']['$mname']['$cname'] = \"$cval\";\n";
					}
					
				}
			}
			$ug = new class_ALiCE_Usergroups;
			foreach($modules as $m => $mval) {	
				if((isset($modules[$m])) && is_array($modules[$m])) {
					foreach($modules[$m]['usertypes'] as $usertypes) {
						$name = $usertypes['name'];
						$ug->delete_all_rightsByType("module_$m",$name);
					}
				}
			}
			if($usertype) {
				foreach($usertype as $mname => $t){
					foreach($t as $tname =>$groups) {
						foreach($groups as $groupid) {
							$ug->insert_rights($groupid,"module_$mname",$tname);
						}
					}
				}
			}
			$modconf .= "\n\n?>";
			$msg = $this->write_moduleconfig($modconf);		
			
			header("Location:$PHP_SELF?$link_info&action=module");
		} 
		$inhalt .= "			
		<form name=\"modulconfigform\" method=\"post\" 
		action=\"$PHP_SELF?$link_info&action=module\">			
		<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\" >
		<tr class=\"alice3\"><td><b>Lese Modulefolder</b></td></tr>
		<tr class=\"alice5\"><td><br>";
		$mymodules 		= $this->read_modulefolder();
		#$mymodules[] 	= "root";
		$i 				= 0;					
		foreach($mymodules as $m) {
			if((isset($ALiCEMODULES[$m])) || $m == 'root') { $sel =1;} else { $sel=0; }
			$inhalt .= $this->get_formModuleconfig($m,$sel,$i);				
			$inhalt .= "<br><br>";
			$i++;
		}
		$inhalt .= "<br><br>
		<input type=\"submit\" name=\"module_submit\" value=\"speichern\"><br><br>
		</td></tr></table></form>";
	
		return $inhalt;
	}
	
	function get_taginfo() {
		$mymodules 		= $this->read_modulefolder();
			$modules 	= $this->modules;
		#$mymodules[] 	= "root";
		$i 				= 0;		
		$r = "<h3>Module- Tag &Uuml;bersicht</h3><hr>";
		foreach($mymodules as $m) {
			if((isset($modules[$m]['tags'])) && is_array($modules[$m]['tags'])) {
			$r .= "<h5><u>$m- Module</u></h5>";
				foreach($modules[$m]['tags'] as $t) {
					$name 		= "{".$t['name']."[]}";
					$dis  		= $t['description'];
					$r    .= "<b>$name</b><br> $dis<br><br>";
				}
			$r .= "<hr>";
			}
		}
		return $r;
	}
	
	function get_formModuleconfig($modulename,$checked,$i) {
		global $PHP_SELF;
		$m = $modulename;
		if($checked == 1) { $sel = "checked"; } else { $sel = ""; }
		$inhalt = "<input type=\"checkbox\" name=\"postmod[$i]\" value=\"$m\" $sel><h4 style=\"display:inline;\">$m</h4><br>";
		if($checked == 1) {
			$modules 	= $this->modules;
			$r1 = "";
			$r2 = "";
			$r3 = "";
			$r4 = "";
			if((isset($modules[$m])) && is_array($modules[$m])) {
				foreach($modules[$m] as $mkey => $mval) {					
					if(count($mval) > 0) {
						 if($mkey == "options") {
						$r1 .= "&nbsp; &nbsp; <h5 style=\"display:inline;\">$mkey</h5><br>
						<div style=\"padding-left:40px;padding-right:80px;\">";
								foreach($mval as $v) {
									$r1 .= "".$this->get_formfieldByOption($m,$v)."";
								}
						$r1 .= "</div>";
						} else if(($mkey == "installer")   ){
							$r4 .= "&nbsp; &nbsp; <h5 style=\"display:inline;\">$mkey</h5><br>
							<div style=\"padding-left:40px;padding-right:80px;\">";
							if ($this->is_installed($m) == 1){
							$r4    .= "<input type=\"button\" name=\"install$m\" value=\"uninstall\"
							onclick=\" popup('$PHP_SELF?action=popup_moduleinstaller&modulename=$m', 'uninstaller', 800, 600)\">
							<br>";
							
							} else {
							
							$r4    .= "<input type=\"button\" name=\"install$m\" value=\"install\"
							onclick=\" popup('$PHP_SELF?action=popup_moduleinstaller&modulename=$m', 'installer', 800, 600)\">
							<br>";
						    }
							$r4 .= "</div>";	
						} else if(($mkey == "tags")   ){
						$r4 .= "&nbsp; &nbsp; <h5 style=\"display:inline;\">$mkey</h5><br>
						<div style=\"padding-left:40px;padding-right:80px;\">";
								foreach($mval as $v) {
									$name 		= $v['name'];
									$dis  		= $v['description'];
									$r4    .= "<u>$name</u><br> $dis<br>";
								}					
						$r4 .= "</div>";	
						} else if( ($mkey == "sections") ){
						$r3 .= "&nbsp; &nbsp; <h5 style=\"display:inline;\">$mkey</h5><br>
						<div style=\"padding-left:40px;padding-right:80px;\">";
								foreach($mval as $v) {
									$name = $v['name'];
									$usertype 	= $v['usertype'];
									$dis  = $v['description'];
									$r3 .= "<u>$name (usertype:$usertype)</u><br> $dis<br>";
								}					
						$r3 .= "</div>";	
						} else if(($mkey == "usertypes") ){	
						$r2 .= "&nbsp; &nbsp; <h5 style=\"display:inline;\">$mkey</h5><br>
						<div style=\"padding-left:40px;padding-right:80px;\">";
								$ug 			 = new class_ALiCE_Usergroups;			
								foreach($mval as $v) {
									$name 	 = $v['name'];
									$dis  	 = $v['description'];
									$r2 .= "<u>$name</u><br> $dis<br>";
									$childs  = $ug->get_allchilds(0);
									$r2 .= $ug->get_groupcheckboxtree($childs,$name,"module_$m","usertype[".$m."][".$name."]");	
								}						
						$r2 .= "</div>";
						} else {
							foreach($mval as $v) {
						$r4 .= "&nbsp; &nbsp; <h5 style=\"display:inline;\">$mkey</h5><br>
						<div style=\"padding-left:40px;padding-right:80px;\">";
								foreach($v as $s => $t) {
								$r4 .= "&nbsp; &nbsp; &nbsp; &nbsp; $s : $t<br>";
								}
						$r4 .= "</div>";
							}
						}
					}
				}
			}
			$inhalt .= "$r1 $r2 $r3 $r4";
		}
		return $inhalt;
	}
	
	
	
			
			
			
			
	function get_formfieldByOption($modulename,$option) {
		global $CONFIG;
		$name 		= $option['name'];
		$type 		= $option['type'];
		$typeset 	= $option['typeset'];
		$value 		= $CONFIG['module'][$modulename][$name];
		if($type == "char") {
			if($typeset > 80) { $sizeset = 80; } else { $sizeset = $typeset; }
			$r = "$name<br><input type=\"text\" name=\"moduleconfig[$modulename][$name]\" value=\"$value\" 
							size=\"$sizeset\" maxlength=\"$typeset\"><br>";
		} else if($type == "int") {
		} else if($type == "bool") {
		} else if($type == "enum") {
		} else if($type == "blob") {
		}
		return $r;
	}
	
	
	function get_sections() {
		global $id;
		$se = array();
		$modules = $this->get_modules();
		foreach ($modules as $m => $val) {
			if(isset($modules[$m]['sections'])) {
				$section = $modules[$m]['sections'];
				foreach($section as $s) {
					$usertype 	= $s['usertype'];  					
					$ug 		= new class_ALICE_Usergroups;
					$rights 	= $ug->check_userrights($id,"module_".$m,$usertype); 
					if($rights) {
					$c = count($se);
					$se[$c]['action'] 	= $s['action']; 
					$se[$c]['name'] 	= $s['name'];  
					}
				}
			}
		}
		return $se;
	}
		
		function sectionweiche($action) {
			$r 					= array();
			$r['local_links'] 	= "";
			$r['titel'] 		= "";
			$r['inhalt'] 		= "";
			$modules = $this->get_modules();
			$i = 0;
			foreach ($modules as $m => $val) {
				if(isset($modules[$m]['sections'])) {
					$section = $modules[$m]['sections'];
					foreach($section as $s) {
						$saction = $s['action'];
						$function = $s['function'];
						if($action == $saction) {
							$r['inhalt'] = $function();
							return $r;
						}
					}
				}
			}
			return $r;
		}
	
	
}


?>