<?
/**
 * 	This file is part of alicecms.
 *
 * alicecms is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * alicecms is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with alicecms; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * @author Timm Maass <info@timm-maass.de>
 * @copyright &copy; 2005-2006 The ALiCE-CMS Project Team
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @package alicecms
 */

class class_ALiCE_Usergroups {

	function get_content(){
		global $tat;
		$r = "<h3>Usergruppen</h3>";
		if ($tat == "loschen") {
			$r .= $this->delete();
		} elseif (($tat == "neu") or ($tat == "bearbeiten")) {
			$r .= $this->view_form();
		} else {
			$r .= $this->view_liste();
		}
		return $r;	
	}
	
	function get_locallinks() {
		global $PHP_SELF, $link_info;
		$r 	= "
		<li><a href=\"$PHP_SELF?action=usergroups&$link_info\">Gruppenliste</a></li>
		<li><a href=\"$PHP_SELF?action=usergroups&tat=neu&g_id=neu$link_info\">Neue Gruppe</a></li>";
		return $r;
	}
	
	function get_title() {
		$r 	= "Usergruppen";
		return $r;		
	}
	
	
	function view_liste() {
		global $PHP_SELF, $link_info, $CONFIG;
		$cdb = new class_mysql;
		$inhalt 	 = "			 
		<table border=\"0\" align=\"center\" class=\"text\" width=\"100%\"  cellpadding=\"0\" cellspacing=\"0\">
		<tr class=\"alice3\"><td colspan=\"4\"><b>Gruppenliste</b></td></tR>
		<tr style=\"font-weight:bold;\" class=\"alice2\"><td><b>Id</b></td><td><b>Name</b></td></tr>";
		$i=1;
		$cdb->select("select * from ".$CONFIG['mysql']['table_usergroups']." order by name");		
		while($row = $cdb->fetchArray()) {
			$gid 		= $row['id'];
			$name		= $row['name'];
			if($i % 2) { $bg="class=\"alice4\""; } else { $bg="class=\"alice5\""; }
			$inhalt .= "
			<tr $bg><td>$gid</td><td>$name</td>
			<td nowrap width=\"80px\">
			<a href=\"$PHP_SELF?action=usergroups&tat=bearbeiten&g_id=$gid&$link_info\">
		    <img src=\"pics/bearbeiten.gif\"  border=\"0\" alt=\"bearbeiten\" title=\"bearbeiten\"></a>
			<a href=\"$PHP_SELF?action=usergroups&tat=bearbeiten&g_id=$gid&$link_info\">
		    <img src=\"pics/loschen.gif\"  border=\"0\" alt=\"lschen\" title=\"lschen\"></a></td></tr>";
		    $i++;
		}		
		$inhalt .= "
		</table><br>
		<a href=\"$PHP_SELF?action=usergroups&tat=neu&g_id=neu$link_info\">
		<img src=\"pics/neu.gif\"  border=\"0\" alt=\"Neue Gruppe\" title=\"Neue Gruppe\"></a>";
		return $inhalt;	
	}
	
	
	
	function view_form() {
		global $tat, $PHP_SELF, $link_info, $CONFIG, $g_id, $msg, $id;
		$msg .= $this->save();
		$cdb = new class_mysql;
		$check = false;
		if ($g_id == "neu") { 
			$gid 		= "neu";
			$name 		= "";
			$parentid	= "";
			$bez		= "Neue Gruppe";
			$check = true;
		} else {
			$cdb->select("select * from ".$CONFIG['mysql']['table_usergroups']." where id = $g_id");
			$row 		= $cdb->fetchArray();
			$gid 		= $row['id'];
			$name 		= $row['name'];
			$parentid 		= $row['parentid'];
			$bez		= "Gruppe $g_id bearbeiten";
			$groupid = $this->groupidByUserid($id);
			$ischild 	= $this->is_child($groupid,$gid);
			if($ischild || ($groupid == $gid)) { $check = true; }
		}	 
		if($check != true) { $msg = "Fehler: Sie haben kein Recht diese Gruppe zu bearbeiten"; return false; }
		$ste = new class_ALiCE_Site;
		$childs = $ste->get_allchilds(0);
		$tree_struktur = $this->get_strukturcheckboxtree($childs,$gid);
		
		$bdr = new class_ALiCE_filesystem;
		$childs = $bdr->get_allfolders();
		$tree_filesystem = $this->get_filesystemcheckboxtree($childs,$gid);
		
		$tree_modules = $this->get_module_usertype_checkboxtree($gid);
		
		$select_parent = $this->groupselecta($parentid,'parentid');		
		
		$check 	= $this->check_rights($gid,"siteadmin",0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$check_siteadmin = "<b><input type=\"checkbox\" name=\"siteadmin\" value=\"0\" $sel>ALiCE Sitedmin</b><br>";
		
		$check 	= $this->check_rights($gid,"user",0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$check_user = "<b><input type=\"checkbox\" name=\"user\" value=\"0\" $sel>User</b><br>";
		
		$check 	= $this->check_rights($gid,"usergroups",0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$check_usergroups = "<b><input type=\"checkbox\" name=\"usergroups\" value=\"0\" $sel>Usergruppen</b><br>";
		
		
		
		$check 	= $this->check_rights($gid,"design",0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$check_design = "<b><input type=\"checkbox\" name=\"design\" value=\"0\" $sel>Design</b><br>";
		
		$check 	= $this->check_rights($gid,"styles",0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$check_styles = "<b><input type=\"checkbox\" name=\"styles\" value=\"0\" $sel>Styles</b><br>";
		
		$check 	= $this->check_rights($gid,"templates",0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$check_templates = "<b><input type=\"checkbox\" name=\"templates\" value=\"0\" $sel>Templates</b><br>";
		
		$r = "
		<form method=\"post\" action=\"$PHP_SELF?action=usergroups&tat=$tat$link_info\" style=\"display:inline;\">
		<input type=\"hidden\" name=\"g_id\" value=\"$gid\">
		<table border=\"0\" align=\"center\" class=\"text\" width=\"100%\"  cellpadding=\"0\" cellspacing=\"0\">
		<tr style=\"font-weight:bold;\" class=\"alice3\">
		<td  colspan=2>$bez&nbsp;&nbsp;</td></tr>
		<tr class=\"alice5\" style=\"padding:10px;\" >
		<td colspan=2>Name<br><input type=\"text\" name=\"name\" value=\"$name\" size=\"30\" maxlenght=\"30\"><br>
		Parent Group<br>$select_parent
		</td></tr>
		<tr class=\"alice5\" style=\"padding:10px;\" valign=\"top\">
		<td>$check_user<br>$check_usergroups<br>$check_siteadmin<br>$check_design <br> $check_styles <br>
		$check_templates <br> $tree_struktur </td><td>$tree_filesystem <br> $tree_modules</td></tr>
		<tr class=\"alice5\" style=\"padding:10px;\" >
		<td align=\"center\" colspan=2>
		<input type=\"submit\" name=\"save\" value=\"Speichern\">
		<input type=\"submit\" name=\"abort\" value=\"Abbrechen\"></td></tr>
		</table></form>";
		return $r;
	}
	
	
	function delete() {
	}
	function save() {
		global $PHP_SELF, $link_info, $CONFIG, $g_id;
		$msg = "";
		if(isset($_POST['save'])) {
			if(isset($_POST['g_id']) && isset($_POST['name']) && isset($_POST['parentid']) ) {
				$cdb = new class_mysql;
				if($_POST['g_id'] == "neu") {
					$cdb->insert("INSERT INTO ".$CONFIG['mysql']['table_usergroups']." VALUES ('','".$_POST['name']."','".$_POST['parentid']."')");
					$g_id 	= $cdb->getLastInsertID();	
					
				} else {
					$query = "UPDATE ".$CONFIG['mysql']['table_usergroups']." SET name='".$_POST['name']."', parentid ='".$_POST['parentid']."'
					WHERE id='".$_POST['g_id']."'";
					$cdb->update($query);	
					$this->delete_all_rights($_POST['g_id']);
					if(isset($_POST['struktur'])) {
						$struktur = $_POST['struktur'];
						foreach($struktur as $s){
							$this->insert_rights($_POST['g_id'],'struktur',$s);
						}
					}
					if(isset($_POST['filesystem'])) {
						$filesystem = $_POST['filesystem'];
						foreach($filesystem as $f){
							$this->insert_rights($_POST['g_id'],'filesystem',$f);
						}
					}
					if(isset($_POST['siteadmin'])) {
							$this->insert_rights($_POST['g_id'],'siteadmin',0);
					}
					if(isset($_POST['user'])) {
							$this->insert_rights($_POST['g_id'],'user',0);
					}
					if(isset($_POST['usergroups'])) {
							$this->insert_rights($_POST['g_id'],'usergroups',0);
					}
					if(isset($_POST['modules'])) {
							$this->insert_rights($_POST['g_id'],'modules',0);
					}
					if(isset($_POST['design'])) {
							$this->insert_rights($_POST['g_id'],'design',0);
					}
					if(isset($_POST['styles'])) {
							$this->insert_rights($_POST['g_id'],'styles',0);
					}
					if(isset($_POST['templates'])) {
							$this->insert_rights($_POST['g_id'],'templates',0);
					}
					if(isset($_POST['modusertypes'])) {
						$modusertypes = $_POST['modusertypes'];
						foreach($modusertypes as $modulname => $modtype){
							$this->insert_rights($_POST['g_id'],'module_'.$modulname,$modtype);
						}
					}
					
				}
			} else { $msg = "Bitte geben Sie alle Daten an"; }			
		}
		if(isset($_POST['abort'])) {
			header("Location: $PHP_SELF?action=usergroups$link_info");			
		}
		return $msg;
	}
	
	
	
	function delete_all_rights($groupid) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->query("delete from ".$CONFIG['mysql']['table_userrechte']." 
					  where groupid = '$groupid'");		
	}
	
	
	function delete_all_rightsByType($type,$value) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->query("delete from ".$CONFIG['mysql']['table_userrechte']." 
					  where gtype = '$type' and  value = '$value'");		
	}
	
	function insert_rights($groupid,$type,$value) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->insert("insert into ".$CONFIG['mysql']['table_userrechte']." 
					  values ('$groupid','$type','$value')");
	}
	
	function insert_rights_recursive($groupid,$type,$value) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->insert("insert into ".$CONFIG['mysql']['table_userrechte']." 
					  values ('$groupid','$type','$value')");
		$cdb->select("select parentid from ".$CONFIG['mysql']['table_usergroups']." where id='$groupid'");
		$daten = $cdb->fetchArray();
		$parentid = $daten[0];
		if($parentid == 0) return;
		$this->insert_rights_recursive($parentid,$type,$value);
		
	}
	
	function check_rights($groupid,$type,$value) {
		global $CONFIG;
		if($groupid == 1) { return true; }
		$cdb = new class_mysql;
		$query = "select * from ".$CONFIG['mysql']['table_userrechte']."
				   where groupid='$groupid' and gtype='$type' and value='$value' ";
		$cdb->select($query);
		$count = $cdb->getRecords();
		if($count == 0) {return false;	} else { return true; }
	}
	
	function get_groupsByRights($type,$value) {
		global $CONFIG;
		$cdb = new class_mysql;
		$query = "select groupid from ".$CONFIG['mysql']['table_userrechte']."
				   where gtype='$type' and value='$value' ";
		$cdb->select($query);
		$r  = array();
		$r[1] = true;
		while($d = $cdb->fetchArray()) {
			$r[$d[0]] = true;
		}
		return $r;
	}
	
	function check_userrights($userid,$type,$value) {
		global $CONFIG;
		$cdb 		= new class_mysql;
		$query 		= "select groupid from ".$CONFIG['mysql']['table_user']."  where userid='$userid' ";
		$cdb->select($query);
		$d 			= $cdb->fetchArray();
		$groupid 	= $d[0];		
		if($groupid == 1) { return true; }
		$query = "select * from ".$CONFIG['mysql']['table_userrechte']."
				   where groupid='$groupid' and gtype='$type' and value='$value' ";
		$cdb->select($query);
		$count = $cdb->getRecords();
		if($count == 0) {return false;	} else { return true; }
	}
	
	function get_module_usertype_checkboxtree($groupid) {
		global $mod;
		$modules = $mod->get_modules();
		$check 	= $this->check_rights($groupid,"modules",0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$r = "<b><input type=\"checkbox\" name=\"modules\" value=\"0\" $sel>Modules</b><br>";

		foreach($modules as $m_name => $m) {
			$u = $m['usertypes'];	
			if(count($u) > 0) {
				foreach($u as $ut) {
					$check = $this->check_rights($groupid,"module_$m_name",$ut['name']);
					if($check == true) { $sel = "checked"; } else { $sel = ""; }
					$r .= "&nbsp;&nbsp;&nbsp;<input type=\"checkbox\" name=\"modusertypes[$m_name]\" 
							value=\"".$ut['name']."\" $sel> $m_name - ".$ut['name']." <br>";
				}
			}
		}		
		return $r;
	}
	
	function get_filesystemcheckboxtree($childs,$groupid) {	
		$check = $this->check_rights($groupid,'filesystem',0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$result = "
		<b><input type=\"checkbox\" name=\"filesystem[]\" value=\"0\" $sel>Filesystem</b><br>";
		$result .= $this->get_filesystemcheckbox($childs,$groupid);
		return $result;
	}	
	
	function get_filesystemcheckbox($childs,$groupid) {
		static $ebene = 0;
		$result = "";
		foreach($childs as $c) {
			$daten = $c['daten'];
			$name = $daten['name'];
			$cchilds = $c['childs'];
			$nbsp = "";
			for($i = 0; $i <= $ebene; $i++) { $nbsp .= "&nbsp;&nbsp;&nbsp;"; }
			$check = $this->check_rights($groupid,'filesystem',"$name");
			
			if($check == true) { $sel = "checked"; } else { $sel = ""; }
			$result .= "$nbsp<input type=\"checkbox\" name=\"filesystem[]\" 
							value=\"".$daten['name']."\" $sel>".$daten['name']."<br>";
			$ebene++;
			$result .= $this->get_filesystemcheckbox($cchilds,$groupid);
			$ebene--;
		}
		return $result;
	}
	
	function get_strukturcheckboxtree($childs,$groupid) {	
		$check = $this->check_rights($groupid,'struktur',0);
		if($check == true) { $sel = "checked"; } else { $sel = ""; }
		$result = "
		<b><input type=\"checkbox\" name=\"struktur[]\" value=\"0\" $sel>Struktur</b><br>";
		$result .= $this->get_strukturcheckbox($childs,$groupid);
		return $result;
	}	
	
	function get_strukturcheckbox($childs,$groupid) {
		static $ebene = 0;
		$result = "";
		foreach($childs as $c) {
			$daten = $c['daten'];
			$cchilds = $c['childs'];
			$nbsp = "";
			for($i = 0; $i <= $ebene; $i++) { $nbsp .= "&nbsp;&nbsp;&nbsp;"; }
			$check = $this->check_rights($groupid,'struktur',$daten['siteid']);
			if($check == true) { $sel = "checked"; } else { $sel = ""; }
			$result .= "$nbsp<input type=\"checkbox\" name=\"struktur[]\" 
							value=\"".$daten['siteid']."\" $sel>".$daten['siteid']." - ".$daten['name']."<br>";
			$ebene++;
			$result .= $this->get_strukturcheckbox($cchilds,$groupid);
			$ebene--;
		}
		return $result;
	}
	
	function get_groupcheckboxtree($childs,$siteid,$rightstype,$fieldname="") {	
		$result = $this->get_groupcheckbox($childs,$siteid,$rightstype,$fieldname);
		return $result;
	}	
	
	function get_groupcheckbox($childs,$siteid,$rightstype,$fieldname="") {
		global $id;
		if($fieldname == "") { $fieldname = $rightstype; }
		$groupid = $this->groupidByUserid($id);
		static $ebene = 0;
		$result = "";
		foreach($childs as $c) {
			$daten = $c['daten'];
			$cchilds = $c['childs'];
			$nbsp = "";
			for($i = 0; $i <= $ebene; $i++) { $nbsp .= "&nbsp;&nbsp;&nbsp;"; }
			$check = $this->check_rights($daten['id'],$rightstype,$siteid);
			if($check == true) { $sel = "checked"; } else { $sel = ""; }
			$ischild = $this->is_child($groupid,$daten['id']);
			if($ischild == true) { $dis = ""; } else { $dis = "DISABLED"; }
			$result .= "$nbsp<input type=\"checkbox\" name=\"".$fieldname."["."]\" 
							value=\"".$daten['id']."\" $sel $dis >".$daten['id']." - ".$daten['name']
							."<br>";
			$ebene++;
			$result .= $this->get_groupcheckbox($cchilds,$siteid,$rightstype,$fieldname);
			$ebene--;
		}
		return $result;
	}
	
	function is_child($groupid,$childid) {
		$childs = $this->get_allchilds($groupid);
		$r = 0;
		foreach($childs as $c) {
			$daten 	= $c['daten'];
			$gid 	= $daten['id'];
			if($gid == $childid) { return 1; }
			$r = $this->is_child($gid,$childid);
			if($r == 1) { return 1; }
		}
		return $r;
	}
	
	
	function get_allchilds($groupid) {
		$childs = $this->get_childs($groupid);		
		return $childs;
	}
	
	function get_childs($groupid) {
		global $CONFIG;
		$r = array();
		$cdb = new class_mysql;
		$cdb->select("select * from ".$CONFIG['mysql']['table_usergroups']." where parentid = $groupid");
		$i = 0;
		while($daten= $cdb->fetchArray()) {
			$sid = $daten['id'];
			$r[$i]['daten'] = $daten;
			$r[$i]['childs'] = $this->get_childs($sid);
			$i++;
		}
		return $r;		
	}
	function groupById($groupid) {
		global $CONFIG;
		$cdb = new class_mysql;
		$cdb->select("SELECT * FROM ".$CONFIG['mysql']['table_usergroups']." where id = '$groupid'");
		$d = $cdb->fetchArray();
		$r = $d['name'];
		return $r;
	}
	
	function groupselecta($selected,$fieldname) {
		global $CONFIG, $id;
		$groupid = $this->groupidByUserid($id);
		$cdb = new class_mysql;
		$r = "<select name=\"$fieldname\">";
		$cdb->select("SELECT * FROM ".$CONFIG['mysql']['table_usergroups']." order by name");
		if($cdb->getRecords() > 0) {
		while($row= $cdb->fetchArray()) {
			$uid 		= $row['id'];
			$name 		= $row['name'];
			$ischild 	= $this->is_child($groupid,$uid);
			if($ischild || ($uid == $groupid)) {
				if($uid == $selected) { $sel = "selected"; } else { $sel = ""; }
				$r .= "<option value=\"$uid\" $sel>$name</option>";
			}
		}
		} else { $r .= "<option vlaue=\"\">Keine Gruppen vorhanden.</option>"; }
		$r .= "</select>";
		return $r;
	}
	
	function groupchecka($arr_selected,$fieldname) {
		global $CONFIG;
		$cdb = new class_mysql;
		$r = "";
		$cdb->select("SELECT * FROM ".$CONFIG['mysql']['table_usergroups']." order by name");
		if($cdb->getRecords() > 0) {
		while($row= $cdb->fetchArray()) {
			$uid 		= $row['id'];
			$name 		= $row['name'];
			if(isset($arr_selected[$uid])) { $sel = "checked"; } else { $sel = ""; }
			$r .= "<input type=\"checkbox\" name=\"".$fieldname."[]\" value=\"$uid\" $sel> $name<br>";
		}
		} else { $r .= "Keine Gruppen vorhanden."; }
		$r .= "";
		return $r;
	}
	function groupidByUserid($userid) {
		global $CONFIG;
		if($userid == "") return false;
		$cdb = new class_mysql;
		$cdb->select("SELECT groupid FROM ".$CONFIG['mysql']['table_user']." where userid = '$userid'");
		$d = $cdb->fetchArray();
		return $d[0];
	}
}

?>